unit uLogbuchII;
{
    Computerlogbuch II
    Copyright (C) 2004 Arne Bochem <complog2@arneb.de>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, uBlowfish, uAboutBox1, Registry, ExtCtrls, Menus, StdCtrls, Spin;

type
  TForm1 = class(TForm)
    Timer1: TTimer;
    MainMenu1: TMainMenu;
    Datei1: TMenuItem;
    Beenden1: TMenuItem;
    N1: TMenuItem;
    Info1: TMenuItem;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Button1: TButton;
    Button2: TButton;
    Passwort: TEdit;
    ID: TSpinEdit;
    Datum: TEdit;
    Titel: TEdit;
    Inhalt: TMemo;
    procedure Timer1Timer(Sender: TObject);
    procedure Info1Click(Sender: TObject);
    procedure Beenden1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure IDChange(Sender: TObject);
    procedure DatumDblClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

var
  NewDatum, NewTitel, NewInhalt : String;
  PrevID : Integer;

procedure TForm1.Timer1Timer(Sender: TObject);
var
  Reg : TRegistry;
begin
  // Check, if we ever ran before.
  Reg := TRegistry.Create;
  try
    Reg.RootKey := HKEY_CURRENT_USER;
    if Not(Reg.OpenKey('\Software\ComputerLogbuchII\Shown', false)) then
      begin
        AboutBox1.Show;
      end;
  finally
    Reg.Free;
  end;
  Timer1.Destroy;
end;

procedure TForm1.Info1Click(Sender: TObject);
begin
  AboutBox1.Show;
end;

procedure TForm1.Beenden1Click(Sender: TObject);
begin
  Application.Terminate;
end;

procedure setMaxId(MaxID : Integer);
var MaxIDFile : File of Integer;
begin
  AssignFile(MaxIDFile, 'id.dat');
  try
    Rewrite(MaxIDFile);
    Write(MaxIDFile, MaxID);
    CloseFile(MaxIDFile);
  except
    // This is really bad. Let's just hide and hope it goes away.
  end;
end;

function getMaxId() : Integer;
var MaxIDFile : File of Integer;
begin
  result := 0;
  AssignFile(MaxIDFile, 'id.dat');
  try
    Reset(MaxIDFile);
    Read(MaxIDFile, result);
    CloseFile(MaxIDFile);
  except
    // This is no good.
    setMaxId(0);
  end;
end;

function makeDateString() : String;
var DateString : String;
begin
  DateString := DateToStr(Date()) + ' ' + TimeToStr(Time());
  result := DateString;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  ID.Value := getMaxId() + 1;
  PrevID := getMaxId() + 1;
  ID.MaxValue := getMaxId() + 1;
  Datum.Text := makeDateString;
end;

procedure SaveToBinFile(Data, filename : String);
var
  BinFile : File of char;
  Character : char;
begin
  AssignFile(BinFile, filename);
  try
    Rewrite(BinFile);
    while Data <> '' do
      begin
        Character := Data[1];
        Delete(Data, 1, 1);
        Write(BinFile, Character);
      end;
  except
    // \\'hatever.
  end;
  CloseFile(BinFile);
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  Serialized : TStringList;
  Temp : String;
  BF : TBlowfish;
begin
  if Passwort.Text = '' then
    begin
      ShowMessage('Bitte Passwort eingeben. Eintrag nicht gespeichert.');
      exit;
    end;
{  if length(Passwort.Text) < 8 then
    begin
      ShowMessage('Das Passwort muss mindestens 8 Zeichen lang sein. Eintrag nicht gespeichert.');
      exit;
    end;}
  // Serialize
  if Datum.Text = '' then
    if ID.Value = getMaxId() + 1 then
      Datum.Text := makeDateString();
  BF := TBlowfish.Blowfish_Init(Passwort.Text);
  Serialized := TStringList.Create;
  Serialized.Sorted := false;
  Serialized.Add(Datum.Text);
  Serialized.Add(Titel.Text);
  Serialized.Add(Inhalt.Lines.Text);
  Temp := Serialized.Text;
  Serialized.Destroy;
  BF.Encipher_CBC(Temp);
  BF.Destroy;
  SaveToBinFile(Temp, IntToStr(ID.Value) + '.dat');
  if ID.Value > getMaxId() then
    begin
      setMaxId(ID.Value);
      ID.MaxValue := ID.Value + 1;
    end;
end;

function LoadFromBinFile(filename : String) : String;
var
  BinFile : File of char;
  BinFileContents : String;
  Character : char;
begin
  result := '';
  try
    BinFileContents := '';
    AssignFile(BinFile, filename);
    Reset(BinFile);
    while Not(eof(BinFile)) do
      begin
        Read(BinFile, Character);
        BinFileContents := BinFileContents + Character;
      end;
    CloseFile(BinFile);
    result := BinFileContents;
  except
    // \\'hatever.
  end;
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  Temp : String;
  BF : TBlowfish;
begin
  Button1.Enabled := true;
  if Passwort.Text = '' then
    begin
      ShowMessage('Bitte Passwort eingeben. Eintrag nicht geladen.');
      exit;
    end;
  // DeSerialize
  BF := TBlowfish.Blowfish_Init(Passwort.Text);
  Temp := LoadFromBinFile(IntToStr(ID.Value) + '.dat');
  if Temp = '' then
    begin
      ShowMessage('Eintrag existiert nicht.');
      exit;
    end;
  BF.Decipher_CBC(Temp);
  BF.Destroy;
  Datum.Text := Copy(Temp, 1, Pos(chr($0d)+chr($0a), Temp) - 1);
  Delete(Temp, 1, Pos(chr($0d)+chr($0a), Temp) + 1);
  Titel.Text := Copy(Temp, 1, Pos(chr($0d)+chr($0a), Temp) - 1);
  Delete(Temp, 1, Pos(chr($0d)+chr($0a), Temp) + 1);
  Inhalt.Lines.Text := Temp;
end;

procedure TForm1.IDChange(Sender: TObject);
begin
  if ID.Value = getMaxId() + 1 then
    begin
      Button1.Enabled := true;
      Datum.Text := NewDatum;
      Titel.Text := NewTitel;
      Inhalt.Lines.Text := NewInhalt;
      PrevID := ID.Value;
      if Datum.Text = '' then
        if ID.Value = getMaxId() + 1 then
          Datum.Text := makeDateString();
    end
  else
    begin
      if PrevID = getMaxId() + 1 then
        begin
          NewDatum := Datum.Text;
          NewTitel := Titel.Text;
          NewInhalt := Inhalt.Lines.Text;
        end;
      Button1.Enabled := false;
      PrevID := ID.Value;
    end;
end;

procedure TForm1.DatumDblClick(Sender: TObject);
begin
  if ID.Value = getMaxId() + 1 then Datum.Text := makeDateString();
end;

end.
